from .core.common import OnApplicationBootstrap, OnModuleInit
from .decorators.controller import api, controller, ctrl, router, rtr
from .decorators.guard import Guard, GuardCb, GuardCtx, GuardExtra, use_guard
from .decorators.handler import delete, get, head, options, patch, post, put, trace
from .decorators.module import dom, domain, mod, module
from .factory import Pest
from .metadata.types.injectable_meta import (
    ClassProvider,
    ExistingProvider,
    FactoryProvider,
    ProviderBase,
    Scope,
    ValueProvider,
)
from .utils.decorators import meta

guard = use_guard

__all__ = [
    'Pest',
    # decorators - module
    'module',
    'mod',
    'domain',
    'dom',
    # decorators - handler
    'get',
    'post',
    'put',
    'delete',
    'patch',
    'options',
    'head',
    'trace',
    # decorators - controller
    'controller',
    'ctrl',
    'router',
    'rtr',
    'api',
    # decorators - utils
    'meta',
    # decorators - guard
    'Guard',
    'GuardCb',
    'GuardExtra',
    'GuardCtx',
    'use_guard',
    'guard',
    # meta - providers
    'ProviderBase',
    'ClassProvider',
    'ValueProvider',
    'FactoryProvider',
    'ExistingProvider',
    'Scope',
    # lifecycle hook protocols
    'OnModuleInit',
    'OnApplicationBootstrap',
]
